From 2c45cb738b02bd45287de3c84b05e4ce6cca14c2 Mon Sep 17 00:00:00 2001
From: Yaakov M. Nemoy <loupgaroublond@gmail.com>
Date: Fri, 19 Dec 2008 18:10:07 -0500
Subject: [PATCH] Replaces a bunch of SQL queries with just one.

---
 v2/grapher.rb |   76 +++++++++++++++++++++++++++-----------------------------
 1 files changed, 37 insertions(+), 39 deletions(-)

diff --git a/v2/grapher.rb b/v2/grapher.rb
index 938e7be..cbb401c 100644
--- a/v2/grapher.rb
+++ b/v2/grapher.rb
@@ -80,7 +80,7 @@ class Grapher
             if (outside_ct > month_ct)
                raise "something wrong here"
             end
-            
+
             inside_data  << inside_ct
             outside_data << outside_ct
             total_data   << month_ct
@@ -99,62 +99,60 @@ class Grapher
 
     def compute_time_dataset2(list,months)
 
-        # return an array of arrays containing the following graphs over time
+      # return an array of arrays containing the following graphs over time
 
-        # total unique posters on list per month in tracked domain A
-        # total unique posters on list per month in tracked domain B (etc)
-        # total unique posters outside of tracked domains
-        
-        inside_data  = []
+      # total unique posters on list per month in tracked domain A
+      # total unique posters on list per month in tracked domain B (etc)
+      # total unique posters outside of tracked domains
 
-        inside_ttl   = 0
+      inside_data  = []
 
-        # puts months
+      inside_ttl   = 0
 
-        domains = @data['colors'].keys().sort()
+      # puts months
 
-        results = {}
+      domains = @data['colors'].keys().sort()
 
+      results = {}
 
-        months.each { |month|
-        
-            query = "select distinct from_addr from posts p where list_id = '#{list}' and url like '%/#{month}/%'"
-            total_ct = Post.connection.select_values(query).length()
- 
-            puts "this month: #{month}"
 
-            color_tags = @data['colors']
+      months.each { |month|
 
-            tracked = 0
-            color_tags.each_pair do |domain, color|       
+        query = "select distinct from_addr, from_domain from posts p where list_id = '#{list}' and url like '%/#{month}/%'"
+        result = Post.connection.select_rows(query)
+        total_ct = result.length
 
-                if not results.has_key?(domain)
-                   results[domain] = []
-                end
 
-           
-                query = "select distinct from_addr from posts p where list_id = '#{list}' and from_domain = '#{domain}' and url like '%/#{month}/%'"
+        puts "this month: #{month}"
 
-                count   = Post.connection.select_values(query).length()
+        color_tags = @data['colors']
 
-                results[domain] << count
+        tracked = 0
+        color_tags.each do |domain, color|
+          if not results.has_key?(domain)
+            results[domain] = []
+          end
 
-                tracked += count
+          count = result.select do |row| row[1] == domain end.length
 
-            end
+          results[domain] << count
 
-            print "total = #{total_ct}"
-            print "tracked = #{tracked}"
-           
-            untracked = total_ct - tracked
-            print "untracked = #{untracked}"
-            results['other'] = [] if not results.has_key?("other")
-            results['other'] << untracked
-            
+          tracked += count
+
+
+        end
+
+        print "total = #{total_ct}"
+        print "tracked = #{tracked}"
+
+        untracked = total_ct - tracked
+        print "untracked = #{untracked}"
+        results['other'] = [] if not results.has_key?("other")
+        results['other'] << untracked
 
-        }
 
-        return results
+      }
+      return results
 
     end
 
-- 
1.6.0.4

